﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace StarCruiser
{
    /// <summary>
    /// Interaction logic for MainUserControl.xaml
    /// </summary>
    public partial class MainUserControl : UserControl
    {
        public System.Random rnd = new Random();

        public MainUserControl()
        {
            InitializeComponent();
            initialize_game();
            show_room();
            szActionDescription =
                "An alien star cruiser has landed near the outskirts of a large town.  A few\n" +
                "aliens have gone in and out from time to time, but nothing big has ever come\n" +
                "from it - until several people tried to explore it.  Very few managed to make\n" +
                "it in, but only one managed to make it out, scribble a note on the side of the\n" +
                "ship, and die immediately afterward.  Now, it's your turn.\n";
            textBox1.Focus();
        }

        protected override void OnRender(DrawingContext drawingContext)
        {
            base.OnRender(drawingContext);
            DrawContents(drawingContext);
        }

        string szRoomDescription;
        string szActionDescription;
        void trim_action_text()
        {
	        while (szActionDescription.Length > 1024)
	        {
                int index = szActionDescription.IndexOf ('\n');
		        if (index == -1)
			        return;
                szActionDescription = szActionDescription.Substring (index + 1);
	        }
        }

        void initialize_game()
        {
            p = new place[]
            {
	            new place ("", 0, 0, 0, 0),
	            new place ("the outside of the star cruiser.\n"
                    + "There's a note on its side saying \"entry word -- ZLP\"", 0, 0, 0, 0),
                new place ("the star cruiser's port of entry", 5, 4, 3, 0),
                new place ("the room of illumination", 6,7,0,2),
                new place ("the room of opening", 2, 0, 7, 0),
                new place ("a very wet room", 0, 2, 6, 0),
                new place ("security outpost # 1", 0, 3, 9, 5),
                new place ("the room of reflection", 3, 0, 0, 4),
                new place ("the weapon's room", 4, 0, 0, 0),  // note the posessive
                new place ("security outpost # 1.5", 0, 11, 0, 6),
                new place ("security outpost # 2", 23, 0, 22, 0),
                new place ("the foot of a southbound iron gate", 9, 0, 0, 0),
                new place ("an \"L\" intersection", 11, 0, 13, 0),
                new place ("the bottom of a hatch", 15, 0 ,14, 12),
                new place ("the room of mystery", 0, 0, 0, 13),
                new place ("the aliens' burial chamber", 0, 13, 0, 0),
                new place ("the top of the hatch", 21, 17, 19, 0),
                new place ("the star cruiser's *strong*-hold", 16, 18, 0, 0),
                new place ("the star cruiser's kitchen", 17, 0, 0, 0),
                new place ("an area with some bars", 21, 0, 0, 16),
                new place ("the round room", 0, 0, 0, 19),
                new place ("a \"T\" intersection", 22, 19, 0, 16),
                new place ("security outpost # 1.7", 0, 21, 0, 10),
                new place ("the *control room*", 0, 10, 0, 0)
            };

            ob = new adventure_object[]
            {
	            new adventure_object ("", 0),
	            new adventure_object ("Bucket of water", 5),
	            new adventure_object ("Dull key", 4),
	            new adventure_object ("Sharp key", 0),
	            new adventure_object ("Button on the south wall", 4),
	            new adventure_object ("Ray gun", 8),
	            new adventure_object ("Shining lamp", 3),
	            new adventure_object ("Hand mirror", 7),
	            new adventure_object ("=Threatening little alien=", 6),
	            new adventure_object ("=Threatening little robot=", 9),
	            new adventure_object ("Closed hatch", 13),
	            new adventure_object ("Mysterious ring", 14),
	            new adventure_object ("Closed coffin", 15),
	            new adventure_object ("Open coffin with key sharpener inside", 0),
	            new adventure_object ("Small envelope", 17),
	            new adventure_object ("Large pill", 0),
	            new adventure_object ("Large amount of good food", 18),
	            new adventure_object ("Set of east-facing, heavily closed bars", 19),
	            new adventure_object ("Silver ball", 20),
	            new adventure_object ("=Deadly prismatic square=", 22),
	            new adventure_object ("Panel of 3 buttons", 23),
	            new adventure_object ("South-facing iron gate", 11)
            };

            cp = 1;
            turnsRemaining = 0;
            mode2 = false;
        }

        void show_room()
        {
	        string [] dir = new string[]
	        {
		        "North", "South", "East", "West"
	        };

            if (cp > 11  &&  ob[6].room != 24  &&  ob[6].room != cp)
            {
                szRoomDescription = "It's too dark to see!";
                return;
            }

	        szRoomDescription = "You are in " + p[cp].name + ".";
	        bool foundOne = false;
            int charColumn = 0;
            for (int i = 1; i < ob.Length; ++i)
		        if (ob[i].room == cp)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "  Visible items:\n\n";
                        foundOne = true;
			        }
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szRoomDescription += "\n";
                        charColumn = 0;
                    }
                    szRoomDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                };
	        foundOne = false;
	        for (int i = 0; i <= 3; ++i)
		        if (p[cp].exit[i] != 0)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "\n\nObvious exits:";
				        foundOne = true;
			        }
			        szRoomDescription += " " + dir[i];
		        }
            if (cp == 1  &&  turnsRemaining > 0)
            {
                szActionDescription += "\nYou've made it outside!\n" +
                    "Suddenly, the entire star cruiser explodes.  You have just saved the Earth from\n"
                    + "alien attack.\n";
                adventure_over();
            }
            else if (ob[8].room == cp)
            {
                szActionDescription += "The alien fires at you!!\n";
                switch (rnd.Next (1, ob[7].room == 24 ? 4 : 3))
                {
                    case 1:
                        szActionDescription += "You successfully dodge the beam!!\n";
                        break;
                    case 2:
                        szActionDescription += "The beam got you!!\n";
                        die();
                        break;
                    case 3:
                        szActionDescription += "The beam bounces harmlessly off your mirror.\n";
                        break;
                }
            }
        }

        void DrawContents(DrawingContext dc)
        {
            Point upperLeftCornerOfTextBox = textBox1.TranslatePoint(new Point(0, 0), this);

            FormattedText ft = new FormattedText(szActionDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
            dc.DrawText (ft, new Point(5, upperLeftCornerOfTextBox.Y - ft.Height - 5));

            ft = new FormattedText(szRoomDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, Brushes.Black);
            dc.DrawRectangle (Brushes.White, null, new Rect (0, 0, 2000, ft.Height + 12));
            dc.DrawText(ft, new Point(5, 5));
            dc.DrawLine (new Pen (Brushes.Black, 1), new Point (0, ft.Height + 10),
                         new Point (2000, ft.Height + 10));
            
            if (textBox1.Visibility == System.Windows.Visibility.Visible)
            {
                ft = new FormattedText ("  ------> What now? ",
                    System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                    new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
                dc.DrawText (ft, new Point (5, upperLeftCornerOfTextBox.Y + 4));
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                // The user pressed enter.  Process the command.
                string szCommand = textBox1.Text;
                szActionDescription += "  ------> What now? " + szCommand + "\n";
                if (mode2)
                {
                    int cmd;
                    if (!int.TryParse (szCommand, out cmd)  ||  cmd < 1  ||  cmd > 4)
                        szActionDescription +=
                            "Enter your choice as button 1, button 2, button 3, or\n" +
                            "4 -- return to normal mode.\n";
                    else if (cmd == 4)
                    {
                        szActionDescription += "You are back in the normal mode.\n";
                        mode2 = false;
                    }
                    else if (cmd == 1)
                    {
                        szActionDescription += "You've started the self-destruct countdown at 20 seconds!!\n";
                        turnsRemaining = 20;
                    }
                    else if (cmd == 2)
                    {
                        if (turnsRemaining > 0)
                        {
                            szActionDescription += "Self-destruct sequence terminated.\n";
                            turnsRemaining = 0;
                        }
                        else
                            szActionDescription += "Nothing happens.\n";
                    }
                    else if (cmd == 3)
                    {
                        szActionDescription +=
                            "You are now the commander of the star cruiser.  Suddenly, Federation H.Q.\n" +
                            "appears on the screen, and tells you that this is the \"Enterprise\", and that\n" +
                            "you must stop the Klingons.  To continue, play \"Another Star-Trek Game\".\n";
                        adventure_over();
                    }
                }
                else
                {
                    int verb;
				    NounType noun;
                    if (input_command (szCommand, out verb, out noun))
                        do_command(verb, noun);
                }
                textBox1.Text = string.Empty;
				trim_action_text();
                InvalidateVisual();
            }
        }


        struct place
        {
	        public string name;
	        public int [] exit;    // 4 exits, one for each direction
            public place (string theName, int north, int south, int east, int west)
            {
                exit = new int[4];
                name = theName;
                exit[0] = north;
                exit[1] = south;
                exit[2] = east;
                exit[3] = west;
            }
        };
        place[] p;

        struct adventure_object
        {
	        public string name;
	        public int room;    // if room == 24, it's in your inventory
            public adventure_object (string theName, int startingRoom)
            {
                name = theName;
                room = startingRoom;
            }
        };
        adventure_object[] ob;

        int cp; // the Current Place in the adventure
        int turnsRemaining;
        bool mode2 = false;

        string verb_str, noun_str;
        enum NounType
        {
            none,
            BUCK, WATE,
            KEY,
            BUTT,
            RAY, GUN,
            LAMP,
            MIRR,
            ALIE,
            ROBO,   // 10
            HATC,
            RING,
            COFF,
            SHAR,
            ENVE,
            PILL,
            FOOD,
            BARS,
            SILV, BALL, // 20
            GATE,
            PRIS, SQUA,
            ZLP,
            last
        }

        private bool input_command (string szCommand, out int verb, out NounType noun)
        {
	        string [] verb_table = new string[]
	        {
		        "",
		        "NORT", "N", "SOUT", "S", "EAST", "E", "WEST", "W",
		        "GET", "TAKE",
		        "DROP", "PUT",
                "ZLP",
                "SPLA",
                "KILL",
                "FIRE", "SHOO",
                "PRES", "PUSH",
                "OPEN", "UNLO",
                "CLIM",
                "EAT",
                "THRO",
                "SHAR",
                "I", "INVE",
                "LOOK",
                "HELP",
                "QUIT",
                "LIFT",
                ".",
                "P",
                "SAY"
	        };
	        string [] noun_table = new string[]
	        {
		        "",
		        "BUCK", "WATE",
		        "KEY",
		        "BUTT",
                "RAY", "GUN",
                "LAMP",
                "MIRR",
                "ALIE",
                "ROBO",
                "HATC",
                "RING",
                "COFF",
                "SHAR",
		        "ENVE",
		        "PILL",
		        "FOOD",
		        "BARS",
		        "SILV", "BALL",
		        "GATE",
		        "PRIS", "SQUA",
		        "ZLP"
	        };
            verb = 0;
            noun = NounType.none;

	        verb_str = string.Empty;
	        noun_str = string.Empty;

	        int i = 0;
	        while (i < szCommand.Length  &&  szCommand[i] != ' ')
		        ++i;
	        verb_str = szCommand.Substring (0, i);
	        if (i < 30)
	        {
		        int j = i;
		        while (j < szCommand.Length  &&  szCommand[j] == ' ')
			        ++ j;
		        if (j < szCommand.Length)
			        noun_str = szCommand.Substring (j);
	        }
            string verbStrToCompare = verb_str;
            if (verbStrToCompare.Length > 4)
                verbStrToCompare = verbStrToCompare.Substring (0,4);
            verbStrToCompare = verbStrToCompare.ToUpper();
            i = 1;
            while (i < verb_table.Length && verbStrToCompare != verb_table[i])
		        ++i;
            if (i < verb_table.Length)
		        verb = i;
	        else
	        {
		        szActionDescription += "I don't know how to \"" + verb_str + "\" something.\n";
		        return false;
	        }
	        if (noun_str != string.Empty)
	        {
                string nounStrToCompare = noun_str;
                if (nounStrToCompare.Length > 4)
                    nounStrToCompare = nounStrToCompare.Substring(0, 4);
                nounStrToCompare = nounStrToCompare.ToUpper();
                NounType n = NounType.none;
                ++n;
                while (n < NounType.last && nounStrToCompare != noun_table[(int)n])
                    ++n;
                if (n < NounType.last)
                    noun = n;
                else
                {
                    szActionDescription += "I don't know what \"" + noun_str + "\" is.\n";
                    return false;
                }
            }
            if (turnsRemaining > 0)
            {
                --turnsRemaining;
                szActionDescription += turnsRemaining + " seconds remain....\n";
                if (turnsRemaining == 0)
                {
                    szActionDescription += "B O O M ! !\n" +
                        "The star cruiser just exploded -- with you in it!!\n";
                    die();
                    return false;
                }
            }
            return true;
        }

        // Master verb function chooser, derived from BASIC on-goto statement.
        private void do_command(int verb, NounType noun)
        {
            switch (verb)
            {
                case 1:
                case 2:
                    move_dir(0);
                    break;
                case 3:
                case 4:
                    move_dir(1);
                    break;
                case 5:
                case 6:
                    move_dir(2);
                    break;
                case 7:
                case 8:
                    move_dir(3);
                    break;
                case 9:
                case 10:
                    verb_take(noun);
                    break;
                case 11:
                case 12:
                    verb_drop(noun);
                    break;
                case 13:
                    verb_zlp();
                    break;
                case 14:
                    verb_splash ();
                    break;
                case 15:
                    verb_kill();
                    break;
                case 16:
                    verb_fire();
                    break;
                case 17:
                    verb_shoot();
                    break;
                case 18:
                case 19:
                    verb_press (noun);
                    break;
                case 20:
                case 21:
                    verb_open(noun);
                    break;
                case 22:
                    verb_climb ();
                    break;
                case 23:
                    verb_eat (noun);
                    break;
                case 24:
                    verb_throw (noun);
                    break;
                case 25:
                    verb_sharpen (noun);
                    break;
                case 26:
                case 27:
                    verb_inventory();
                    break;
                case 28:
                    verb_look();
                    break;
                case 29:
                    verb_help();
                    break;
                case 30:
                    verb_quit();
                    break;
                case 31:
                    verb_lift (noun);
                    break;
                case 32:
                    verb_take(noun);
                    break;
                case 33:
                    verb_drop(noun);
                    break;
                case 34:
                    verb_say (noun);
                    break;
            }
            show_room();
        }

        private void move_dir(int direc)
        {
	        if (p[cp].exit[direc] == 0)
            {
                if (cp > 11  &&  ob[6].room != cp  &&  ob[6].room != 24)
                {
                    szActionDescription += "You fell and broke your neck!  You're dead!\n";
                    adventure_over();
                }
                else
    		        szActionDescription += "There is no way to go that direction.\n";
            }
            else if (ob[9].room == cp  &&  direc == 1)
                szActionDescription += "The robot will not let you pass!\n";
            else if (ob[6].room == cp &&  (direc == 1  ||  direc == 3))
                szActionDescription += "The alien will not let you pass!\n";
            else if (ob[19].room == cp && direc == 3)
                szActionDescription += "The prismatic square will not let you pass!\n";
            else
	        {
    		    cp = p[cp].exit[direc];
		        szActionDescription += "Ok\n";
	        }
        }

        private void verb_what()
        {
            szActionDescription += verb_str + " what?\n";
        }

        private int MapNounToObject (NounType noun, int room)
        {
            switch (noun)
            {
                case NounType.BUCK:
                case NounType.WATE:
                    return 1;
                case NounType.KEY:
                    if (ob[2].room == room)
                        return 2;
                    else
                        return 3;
                case NounType.BUTT:
                    if (ob[20].room == room)
                        return 20;
                    else
                        return 4;
                case NounType.RAY:
                case NounType.GUN:
                    return 5;
                case NounType.LAMP:
                    return 6;
                case NounType.MIRR:
                    return 7;
                case NounType.ALIE:
                    return 8;
                case NounType.ROBO:
                    return 9;
                case NounType.HATC:
                    return 10;
                case NounType.RING:
                    return 11;
                case NounType.COFF:
                    if (ob[12].room == room)
                        return 12;
                    else
                        return 13;
                case NounType.SHAR:
                    return 13;
                case NounType.ENVE:
                    return 14;
                case NounType.PILL:
                    return 15;
                case NounType.FOOD:
                    return 16;
                case NounType.BARS:
                    return 17;
                case NounType.SILV:
                case NounType.BALL:
                    return 18;
                case NounType.GATE:
                    return 21;
                case NounType.PRIS:
                case NounType.SQUA:
                    return 19;
            }
            return 0;
        }

        private void verb_take (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.BUTT  ||
                     noun == NounType.ALIE  ||
                     noun == NounType.ROBO  ||
                     noun == NounType.HATC  ||
                     noun == NounType.COFF  ||
                     noun == NounType.SHAR  ||
                     noun == NounType.BARS  ||
                     noun > NounType.BALL)
                szActionDescription += "It's beyond your power to do that.\n";
            else
            {
                int numItemsCarried = 0;
                for (int i = 1; i < ob.Length; ++i)
                    if (ob[i].room == 24)
                        ++ numItemsCarried;
                if (numItemsCarried > 6)
                    szActionDescription += "You are currently holding too much. Try: TAKE INVENTORY\n";
                else
                {
                    int o = MapNounToObject (noun, cp);
                    if (ob[o].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        ob[o].room = 24;
                    }
                }
            }
        }

        private void verb_drop (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else
            {
                int o = MapNounToObject(noun, 24);
                if (ob[o].room != 24)
                    szActionDescription += "You don't have it.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[o].room = cp;
                }
            }
        }

        private void verb_zlp()
        {
            if (cp > 2)
                szActionDescription += "Nothing happens.";
            else if (cp == 2)
            {
                szActionDescription += "Ok\n";
                cp = 1;
            }
            else
            {
                szActionDescription += "Ok\n";
                cp = 2;
            }
        }

        private void verb_splash()
        {
            if (ob[1].room != 24)
                szActionDescription += "You have nothing to splash with!\n";
            else if (ob[9].room != cp)
                szActionDescription += "The ground is wet.  The bucket mystically refills!\n";
            else
            {
                szActionDescription +=
                    "As the bucket mystically refills, the water hits the robot and short-circuits\n" +
                    "it!  It suddenly disintegrates.\n";
                ob[9].room = 0;
            }
        }

        private void verb_kill()
        {
            szActionDescription += "Be more specific as to how.\n";
        }

        private void verb_fire()
        {
            if (ob[5].room != 24)
                szActionDescription += "You've nothing to " + verb_str + "!!\n";
            else
                szActionDescription += "Try: SHOOT.\n";
        }

        private void verb_shoot()
        {
            if (ob[5].room != 24)
                szActionDescription += "You've nothing to shoot with!!\n";
            else if (ob[9].room == cp  ||  ob[19].room == cp)
                szActionDescription += "The beam reflects harmlessly off the opponent's shiny surface!!\n";
            else if (ob[8].room != cp)
                szActionDescription += "There is nothing here to attack!!\n";
            else if (rnd.Next (1, 3) == 1)
                szActionDescription += "The alien dodges, and you miss!!\n";
            else
            {
                szActionDescription += "You've disintegrated a little alien.\n" +
                    "His body vanishes in a cloud of greasy black smoke.\n";
                ob[8].room = 10;
                if (cp == 10)
                    ob[8].room = 0;
            }
        }

        private void verb_press (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BUTT)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + "!!\n";
            else if (ob[4].room == cp)
            {
                szActionDescription += "The south wall suddenly flies open.\n";
                ob[4].room = 0;
                p[4].exit[1] = 8;
            }
            else if (ob[20].room != cp)
                szActionDescription += "There are no buttons here to " + verb_str + "!!\n";
            else
            {
                szActionDescription += "You are now in Mode 2.\n" +
                    "Enter your choice as button 1, button 2, button 3, or\n" +
                    "4 -- return to normal mode.\n";
                mode2 = true;
            }
        }

        private void verb_open(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.ENVE)
                if (ob[14].room != 24)
                    szActionDescription += "You have no " + noun_str + " to " + verb_str + "!!\n";
                else if (ob[15].room != 0)
                    szActionDescription += "You've already opened it.\n";
                else
                {
                    szActionDescription += "There is a " + ob[15].name + " inside.\n";
                    ob[15].room = 24;
                }
            else if (noun == NounType.COFF)
                if (ob[12].room != cp)
                    szActionDescription += "There is no " + noun_str + " here to " + verb_str + "!!\n";
                else if (ob[11].room != 24)
                    szActionDescription += "The coffin refuses to open.\n";
                else
                {
                    szActionDescription += "The coffin opens mysteriously.\n";
                    ob[12].room = 0;
                    ob[13].room = cp;
                }
            else if (noun == NounType.HATC)
                if (ob[10].room != cp)
                    szActionDescription += "There is no " + noun_str + " here to " + verb_str + "!!\n";
                else if (ob[3].room == 24)
                {
                    szActionDescription += "Ok, it's opened.\n";
                    ob[10].room = 0;
                }
                else if (ob[2].room == 24)
                    szActionDescription += "Your key won't fit!!\n";
                else
                    szActionDescription += "You don't have a key!!\n";
            else if (noun == NounType.BARS)
                if (ob[17].room != cp)
                    szActionDescription += "There are no " + noun_str + " here to " + verb_str + "!!\n";
                else
                    szActionDescription += "They have no keyhole.\n";
            else if (noun == NounType.GATE)
                if (ob[21].room != cp)
                    szActionDescription += "There is no gate here!!\n";
                else if (ob[2].room != 24  &&  ob[3].room != 24)
                    szActionDescription += "You don't have a key!!\n";
                else
                {
                    szActionDescription += "Ok, it's opened southward.\n";
                    ob[21].room = 0;
                    p[cp].exit[1] = 12;
                }
            else
                szActionDescription += "You can't " + verb_str + " a " + noun_str + "!!\n";
        }

        private void verb_climb()
        {
            if (cp != 13  &&  cp != 16)
                szActionDescription += "NO!\n";
            else if (ob[10].room == cp)
                szActionDescription += "You can't climb through a closed hatch!!\n";
            else
            {
                szActionDescription += "Ok\n";
                if (cp == 16)
                    cp = 13;
                else
                    cp = 16;
            }
        }

        private void verb_eat (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.PILL)
                if (ob[15].room != 24)
                    szActionDescription += "You don't have a " + noun_str + "!!\n";
                else
                {
                    szActionDescription += "You suddenly become very strong.\n";
                    ob[15].room = 25;   // room 25 is the player's stomach
                }
            else if (noun != NounType.FOOD)
                szActionDescription += "You can't eat a " + noun_str + "!!\n";
            else if (ob[16].room != 24)
                szActionDescription += "You don't have any " + noun_str + "!!\n";
            else
            {
                szActionDescription += "Thank you, it was delicious!\n";
                ob[16].room = 0;
            }
        }

        private void verb_throw(NounType noun)
        {
            if ((noun == NounType.SILV  ||  noun == NounType.BALL)  &&  ob[19].room == cp)
                if (ob[18].room != 24)
                    szActionDescription += "You don't have a " + noun_str + " to " + verb_str + "!!\n";
                else
                {
                    szActionDescription += "The " + noun_str + " dents the prismatic square out of existence!\n";
                    ob[18].room = cp;
                    ob[19].room = 0;
                }
            else
                verb_drop (noun);
        }

        private void verb_sharpen (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.KEY)
                szActionDescription += "Sorry, a " + noun_str + " can't be sharpened.\n";
            else if (ob[3].room == 24)
                szActionDescription += "It's already sharpened.\n";
            else if (ob[2].room != 24)
                szActionDescription += "You don't have a " + noun_str + " to " + verb_str + "!!\n";
            else if (ob[13].room != cp)
                szActionDescription += "There is no sharpener here!\n";
            else
            {
                szActionDescription += "Your key is now sharp.\n";
                ob[2].room = 0;
                ob[3].room = 24;
            }
        }

        private void verb_inventory()
        {
            szActionDescription += "You are currently holding the following:\n";
            bool foundOne = false;
            int charColumn = 0;
            for (int i = 0; i < ob.Length; ++i)
                if (ob[i].room == 24)
                {
                    foundOne = true;
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szActionDescription += "\n";
                        charColumn = 0;
                    }
                    szActionDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                }
            if (!foundOne)
                szActionDescription += "Nothing at all";
            szActionDescription += "\n";
        }

        private void verb_look()
        {
            szActionDescription += "You see nothing special.\n";
        }

        private void verb_help()
        {
            szActionDescription += "Help yourself!\n";
        }

        private void verb_quit()
        {
            szActionDescription += "Coward!\n";
            adventure_over();
        }

        private void verb_lift (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BARS)
                szActionDescription += "It's unliftable.\n";
            else if (ob[17].room != cp)
                szActionDescription += "There isn't any " + noun_str + " here.\n";
            else if (ob[15].room != 25) // pill isn't in the player's stomach
                szActionDescription += "You're not *strong* enough!!\n";
            else
            {
                szActionDescription += "The bars are ripped out of existence.  A passage now leads east.\n";
                ob[17].room = 0;
                p[19].exit[2] = 20;
            }
        }

        private void verb_say (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else
            {
                szActionDescription += "Ok, \"" + noun_str + "\"\n";
                if (noun == NounType.ZLP)
                    verb_zlp();
            }
        }

        internal void verb_save()
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null  &&  result == true)
            {
                string filename = dlg.FileName;
                StreamWriter f;
                try
                {
                    f = new StreamWriter(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error creating file \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                for (int i = 0; i < ob.Length; ++i)
                    f.WriteLine(ob[i].room);
                f.WriteLine(p[4].exit[1]);
                f.WriteLine(p[11].exit[1]);
                f.WriteLine(p[19].exit[2]);
                f.WriteLine(cp);
                f.WriteLine(turnsRemaining);
                f.Flush();
                f.Close();
            }
        }

        internal void verb_load()
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null && result == true)
            {
                string filename = dlg.FileName;
                StreamReader fs;
                try
                {
                    fs = new StreamReader(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Could not open \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                try
                {
                    string s;
                    for (int i = 0; i < ob.Length; ++i)
                    {
                        s = fs.ReadLine();
                        ob[i].room = int.Parse (s);
                    }
                    s = fs.ReadLine();
                    p[4].exit[1] = int.Parse (s);
                    s = fs.ReadLine();
                    p[11].exit[1] = int.Parse(s);
                    s = fs.ReadLine();
                    p[19].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    cp = int.Parse(s);
                    s = fs.ReadLine();
                    turnsRemaining = int.Parse(s);
                    fs.Close();
                    show_room();
                    InvalidateVisual();
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error reading \"" + filename + "\":\n" + ex.Message + "\n";
                    // The game is now in a hopelessly mangled state.  Better give up.
                    adventure_over();
                    return;
                }

            }
        }

        private void die()
        {
            szActionDescription += "Aw!  You seem to have gotten yourself killed.\n";
            adventure_over();
        }

        private void adventure_over()
        {
            textBox1.Visibility = System.Windows.Visibility.Hidden;
            // TODO: gray out the "save game" option.
            szActionDescription += "\n\nThe adventure has ended.\n\n";
        }
    }
}
